=== renderjob/CMakeLists.txt ===
PROJECT(renderjob)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

ADD_EXECUTABLE(k3d-renderjob main.cpp)
TARGET_LINK_LIBRARIES(k3d-renderjob k3dsdk)
IF(WIN32 AND K3D_COMPILER_GCC)
	SET_TARGET_PROPERTIES(k3d-renderjob PROPERTIES LINK_FLAGS -mwindows)
ENDIF(WIN32 AND K3D_COMPILER_GCC)

INSTALL(TARGETS k3d-renderjob DESTINATION bin)
