=== resource-compiler/CMakeLists.txt ===
PROJECT(k3d-resource-compiler)

INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})

ADD_EXECUTABLE(k3d-resource-compiler main.cpp)
TARGET_LINK_LIBRARIES(k3d-resource-compiler ${K3D_BOOST_PROGRAM_OPTIONS_LIBS})
