=== debian/changelog ===
k3d (0.8.0.2-9) unstable; urgency=low

  * Add '--remove-section=.note' when stripping *.module files
  * Changed debhelper compat to level 8 (level 7 before), no changes needed
  * Build-Depends on libjpeg-dev instead of libjpeg62-dev
  * Overriding lintian errors of embedded libraries while waiting for a reply
    from upstream, it's not straightforward to unravel:
    - 'embedded-library usr/lib/libk3dsdk-ftgl.so.1: ftgl'
    - 'embedded-library usr/lib/libk3dsdk-glew.so.1: glew'

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 10 Jul 2011 01:09:00 +0200

k3d (0.8.0.2-8) unstable; urgency=low

  * Rebuild for imagemagick4 transition (Closes: #625576)
  * Bump Standards-Version to 3.9.2 (no changes needed)
  * Simplifying a lot debian/rules file by leveraging debhelper capabilities,
    only acting when deviating from auto behaviour

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sat, 28 May 2011 03:21:18 +0200

k3d (0.8.0.2-7) unstable; urgency=low

  * Remove build dependency on libopencascade-dev, since the opencascade module
    uses k3d::gprim_factory which has been removed, and thus it's not enabled at
    build time anyway (Closes: #616668).  Thanks Denis Barbier for the heads-up.
  * Seems to build fine on GCC-4.5 (Closes: #565008), default compiler on
    unstable at this time (on most architectures, anyway).  The problem was most
    likely occuring in libsigc++-2.0 for some reason, and has been fixed since
    then.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 13 Apr 2011 15:55:55 +0200

k3d (0.8.0.2-6) unstable; urgency=low

  * Adding .desktop file so it appears in menus

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 07 Jan 2011 16:32:26 +0100

k3d (0.8.0.2-5) unstable; urgency=low

  * Using "dh_shlibdeps -a -- debian/k3d/usr/lib/k3d/plugins/*.module" to have
    shared lib dependencies right, so the module TimeSource (and others) do not
    fail to load when the program starts (Closes: #609200).  Thanks to Paul Wise
    <pabs@d.o> for the tip.
  * Change Build-Depends to depend on Boost >= 1.42 (were ">> 1.42" before,
    which do not exist, but were pulled in somehow, maybe by other dependencies)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 07 Jan 2011 12:31:08 +0100

k3d (0.8.0.2-4) unstable; urgency=low

  * Make libinotifytools-dev conditional with [!kfreebsd-i386 !kfreebsd-amd64
  !hurd-i386], it's not available in these architectures and [linux-any] does
  not work (Closes: #592532)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 13 Aug 2010 00:12:37 +0200

k3d (0.8.0.2-3) unstable; urgency=low

  * Bump Standards-Version to 3.9.1 (no changes needed)
  * Use Breaks and Replaces to allow for smooth upgrades without errors,
    caused by files from one package overriding others (Closes: #588604)
  * Change the package to priority "extra", optional is for "all the
    software that you might reasonably want to install if you didn't
    know what it was and don't have specialized requirements".  This is
    not the case, and additionally debcheck reports that it depends on
    software with "extra" priority (libxcb-render-util0), which should
    not happen.
  * Use -mlong-calls in addition to -ffunction-sections in HPPA,
    hopefully this time it will work fine (Closes: #588923)
  * Quell lintian:
    - quilt-patch-missing-description (bug_554930-ftbfs-gold.patch)
    - duplicate-short-description (k3d k3d-data)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Thu, 12 Aug 2010 13:32:42 +0200

k3d (0.8.0.2-2) unstable; urgency=low

  * Put myself in the Uploaders field, add DM-Upload-Allowed: yes
  * Added patch for FTBFS with binutils-gold (Closes: #554930)
  * Use Breaks instead of Conflicts (lintian: conflicts-with-version)
  * Create k3d-data binary package (lintian: arch-dep-package-has-big-usr-share)
  * Added --remove-section=.comment when stripping by hand (lintian:
    binary-has-unneeded-section)
  * Use special "CXXFLAGS += -ffunction-sections" on hppa architecture,
    otherwise the build fails at 17% (let's hope there're no more errors...).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 07 Jul 2010 02:08:31 +0200

k3d (0.8.0.2-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (Closes: #581590).
    - Probably fixed the important bug during the 3 years since last
      release (Closes: #443684).
  * Updated man pages with 'help2man -N --no-discard-stderr"
  * Changed debhelper compat to level 7
  * Added 'watch' file
  * Added 'source/format', with '3.0 (quilt)'
  * Bump Standards-Version to 3.9.0
  * Quelling lintian warnings:
    - out-of-date-standards-version 3.8.0
    - package-uses-deprecated-debhelper-compat-version 4
    - patch-system-but-no-source-readme (now format 3.0 quilt)
    - copyright-refers-to-versionless-license-file (now pointing to GPL-2)
    - debhelper-but-no-misc-depends (added)
    - binary-without-manpage (added manpages)
    - duplicate-font-file (depend on ttf-bitstream-vera and symlink)
  * Dropped all patches:
    * applied upstream:
      - 03_desktop_file_compliant.patch
      - 08_sigc++_headers.patch
    * uses CMake instead of autotools, not applicable anymore:
      - 01_imagemagick_paths.patch
      - 02_boost-mt_libs.patch
      - 04_config.guess-sub_update.patch
    * new upstream doesn't need them:
      - 05_gcc4.3_build.patch
      - 07_gcc4.4_build.patch
    * file doesn't exist anymore:
      - 06_bashisms.patch

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 30 Jun 2010 16:51:25 +0200

k3d (0.6.7.0-2.6) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch to fix FTBFS due to missing headers. (Closes: #571021)
    Thanks to Ilya Barygin <barygin@gmail.com> for the patch.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sun, 21 Mar 2010 12:15:43 +0100


