=== debian/control ===
Source: k3d
Section: graphics
Priority: extra
Maintainer: David Martínez Moreno <ender@debian.org>
Uploaders: Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8.0.0), quilt, cmake (>> 2.6), pkg-config, zlib1g-dev, uuid-dev, libsigc++-2.0-dev, libglibmm-2.4-dev, libgtkmm-2.4-dev, libgnomevfs2-dev, libgtksourceview2.0-dev, libgtkglext1-dev, libcairomm-1.0-dev, libdbus-glib-1-dev, libinotifytools-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libxml2-dev | libexpat1-dev, libfreetype6-dev, libboost-dev (>= 1.42), libboost-date-time-dev (>= 1.42), libboost-regex-dev (>= 1.42), libboost-program-options-dev (>= 1.42), libboost-test-dev (>= 1.42), libboost-python-dev (>= 1.42), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libpng-dev, librsvg2-dev, libjpeg-dev, libopenexr-dev, libtiff4-dev, libmagick++-dev, lib3ds-dev, libgts-dev, python-dev, python-support, graphviz, libsuperlu3-dev, libode-dev, gettext, ttf-bitstream-vera (>= 1.10)
Standards-Version: 3.9.2
Homepage: http://www.k-3d.org/
Vcs-Hg: http://k3d.hg.sourceforge.net:8000/hgroot/k3d/k3d
Vcs-Browser: http://k3d.hg.sourceforge.net/hgweb/k3d/k3d/

Package: k3d
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, k3d-data (= ${source:Version})
Replaces: k3d-dev (<< 0.8.0.1)
Breaks: k3d-dev (<< 0.8.0.1)
Description: 3D modeling and animation system, binary files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains binaries and libraries.

Package: k3d-data
Architecture: all
Replaces: k3d (<< 0.8.0.2-2)
Breaks: k3d (<< 0.8.0.2-2)
Depends: ${misc:Depends}
Description: 3D modeling and animation system, data files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains data needed by the binaries (shaders, GUI elements, ...).
